#pragma once

// STD/STL
#include <memory>
#include <string>
#include <numeric>

// Memory
#include <RobotAPI/libraries/aron/core/navigator/data/forward_declarations.h>
#include <RobotAPI/libraries/aron/core/navigator/type/forward_declarations.h>

// JSON
#include <SimoxUtility/json/json.hpp>

namespace armarx::aron::converter
{
    class AronNlohmannJSONConverter
    {

    public:
        AronNlohmannJSONConverter() = delete;

        static nlohmann::json ConvertToNlohmannJSON(const datanavigator::DictNavigatorPtr&);
        static void ConvertToNlohmannJSON(const datanavigator::DictNavigatorPtr&, nlohmann::json&);

        static datanavigator::DictNavigatorPtr ConvertFromNlohmannJSON(const nlohmann::json&);
        static void ConvertFromNlohmannJSON(datanavigator::DictNavigatorPtr&, const nlohmann::json&, const aron::typenavigator::NavigatorPtr& = nullptr);
    };
}
